SystemOrganization addCategory: #'Xenon-Tests'!
SystemOrganization addCategory: #'Xenon-Tests-Scenarios'!
SystemOrganization addCategory: #'Xenon-Tests-Temporaries'!
SystemOrganization addCategory: #'Xenon-Tests-Operators'!
SystemOrganization addCategory: #'Xenon-Tests-Function'!
SystemOrganization addCategory: #'Xenon-Tests-If'!
SystemOrganization addCategory: #'Xenon-Tests-While'!
SystemOrganization addCategory: #'Xenon-Tests-Semantic'!
SystemOrganization addCategory: #'Xenon-Tests-Scenario-UI'!
SystemOrganization addCategory: #'Xenon-Tests-Util'!
SystemOrganization addCategory: #'Xenon-Tests-Struct'!

Model subclass: #XeScenarioBrowserUI
	instanceVariableNames: 'actual expected diff model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenario-UI'!

!XeScenarioBrowserUI commentStamp: 'BernardoContreras 8/19/2012 05:10' prior: 0!
Knows how to display a scenario in the UI
Instance Variables:
actual
	- the actual translation
diff
	- the diff between the actual and the expected translation
expected
	-  the expected translation
model
	- the scenario to browse
	
!

!XeScenarioBrowserUI class methodsFor: 'instance creation' stamp: 'BernardoContreras 5/5/2012 23:05'!
on: aScenarioBrowser 
	^ self new on: aScenarioBrowser.! !

!XeScenarioBrowserUI methodsFor: 'accessing' stamp: 'BernardoContreras 8/19/2012 03:50'!
actualContents
	^ model actualContents 
	! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 03:08'!
actualFrame
	^ LayoutFrame new
		leftFraction: 0.66 offset: 0;
		topFraction: 0 offset: self labelHeight;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated ! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 03:07'!
actualLabelFrame
	^ LayoutFrame new
		leftFraction: 0.66 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 0.3 offset: 0! !

!XeScenarioBrowserUI methodsFor: 'button behavior' stamp: 'BernardoContreras 8/19/2012 03:50'!
browseButtonAction
	Smalltalk tools browser newOnClass: model scenario! !

!XeScenarioBrowserUI methodsFor: 'button behavior' stamp: 'BernardoContreras 6/4/2012 19:37'!
browseButtonLabel
	^ 'Browse'! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 02:02'!
buildActual
	actual := (PluggableTextMorph on: self text: #actualContents accept: nil)
		disable;
		font: StandardFonts defaultFont;
		yourself.
	^ actual! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 8/31/2012 23:22'!
buildActualLabel
	^ StringMorph contents: 'Actual' font: StandardFonts defaultFont emphasis: 1! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 02:34'!
buildButtons
	^ PluggablePanelMorph newRow
		model: self;
		layoutInset: 0;
		color: Color transparent;
		addAllMorphs:
				(self buttons
						collect: [ :each | 
							(PluggableButtonMorph
								on: self
								getState: nil
								action: each second
								label: each first)
								hResizing: #spaceFill;
								yourself ]);
		yourself! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 02:03'!
buildDiff
	diff := (PluggableTextMorph on: self text: #diffContents accept: nil)
		disable;
		font: StandardFonts defaultFont;
		yourself.
	^ diff! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 8/30/2012 21:43'!
buildDiffLabel
	^ StringMorph contents: 'Diff' font: StandardFonts defaultFont emphasis: 1! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 02:04'!
buildExpected
	diff := (PluggableTextMorph on: self text: #expectedContents accept: nil)
		disable;
		font: StandardFonts defaultFont;
		yourself.
	^ diff! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 8/30/2012 21:43'!
buildExpectedLabel
	^ StringMorph contents: 'Expected' font: StandardFonts defaultFont emphasis: 1! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 02:59'!
buildWindow
	| window |
	window := (SystemWindow labelled: model asString) model: self.
	window addMorph: self buildExpectedLabel fullFrame: self expectedLabelFrame.
	window addMorph: self buildExpected fullFrame: self expectedFrame.
	window addMorph: self buildDiffLabel fullFrame: self diffLabelFrame.
	window addMorph: self buildDiff fullFrame: self diffFrame.
	window addMorph: self buildActualLabel fullFrame: self actualLabelFrame.
	window addMorph: self buildActual fullFrame: self actualFrame.
	window addMorph: self buildButtons fullFrame: self buttonsFrame.
	^ window! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 03:13'!
buttonHeight
	^ StandardFonts defaultFont height  + 14! !

!XeScenarioBrowserUI methodsFor: 'accessing-ui' stamp: 'BernardoContreras 8/30/2012 19:49'!
buttons
	^ #(#(#refreshButtonLabel #refreshButtonAction) #(#browseButtonLabel #browseButtonAction))! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 8/31/2012 23:24'!
buttonsFrame
	^ LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 1 offset: self buttonHeight negated;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: 0! !

!XeScenarioBrowserUI methodsFor: 'accessing' stamp: 'BernardoContreras 8/19/2012 03:01'!
diffContents
	^ TextDiffBuilder buildDisplayPatchFrom: self actualContents to: self expectedContents ! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 8/31/2012 23:24'!
diffFrame
	^ LayoutFrame new
		leftFraction: 0.33 offset: 0;
		topFraction: 0 offset: self labelHeight;
		rightFraction: 0.66 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 03:07'!
diffLabelFrame
	^ LayoutFrame new
		leftFraction: 0.33 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0.66 offset: 0;
		bottomFraction: 0.3 offset: 0! !

!XeScenarioBrowserUI methodsFor: 'accessing' stamp: 'BernardoContreras 8/19/2012 03:50'!
expectedContents
	^ model expectedContents! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 03:08'!
expectedFrame
	^ LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: self labelHeight;
		rightFraction: 0.33 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated ! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 9/2/2012 03:06'!
expectedLabelFrame 
	^ LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0.33 offset: 0;
		bottomFraction: 0.3 offset: 0! !

!XeScenarioBrowserUI methodsFor: 'building' stamp: 'BernardoContreras 8/31/2012 23:15'!
labelHeight
	^ StandardFonts defaultFont height ! !

!XeScenarioBrowserUI methodsFor: 'initialize-release' stamp: 'BernardoContreras 8/19/2012 03:50'!
on: aScenarioBrowser
	model := aScenarioBrowser.
	model announcer on: XeScenarioChanged send: #scenarioChanged to: self! !

!XeScenarioBrowserUI methodsFor: 'display' stamp: 'BernardoContreras 5/5/2012 23:17'!
open
	self buildWindow openInWorld 
	! !

!XeScenarioBrowserUI methodsFor: 'button behavior' stamp: 'BernardoContreras 9/2/2012 03:13'!
refreshButtonAction
	model scenarioChanged! !

!XeScenarioBrowserUI methodsFor: 'button behavior' stamp: 'BernardoContreras 6/4/2012 19:37'!
refreshButtonLabel
	^ 'Refresh'! !

!XeScenarioBrowserUI methodsFor: 'announcements' stamp: 'BernardoContreras 8/19/2012 05:05'!
scenarioChanged
	expected update: #expectedContents.
	actual update: #actualContents.
	diff update: #diffContents! !

Announcement subclass: #XeScenarioChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenario-UI'!

!XeScenarioChanged commentStamp: 'BernardoContreras 8/18/2012 02:06' prior: 0!
When a testing scenario changed.!

XeObject subclass: #XeAddHeaderFileOnCGScenario
	uses: XeDefineOnCG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeAddHeaderFileOnCGScenario commentStamp: 'BernardoContreras 6/20/2012 17:46' prior: 0!
cg addHeaderFile: '"dummy.h"'
==>
#include "dummy.h"
!

XeAddHeaderFileOnCGScenario class
	uses: XeDefineOnCG classTrait
	instanceVariableNames: ''!

!XeAddHeaderFileOnCGScenario class methodsFor: 'translation' stamp: 'BernardoContreras 6/20/2012 02:01'!
defineOn: cg
	cg addHeaderFile: '"dummy.h"'! !

!XeAddHeaderFileOnCGScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/25/2012 16:52'!
expectedOn: writer
	writer
		include: '"dummy.h"';
		functionPrototypesComment! !

XeObject subclass: #XeAssignmentInExpressionScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Operators'!

!XeAssignmentInExpressionScenario commentStamp: '<historical>' prior: 0!
variable := expression 
==> 
variable = expression!

!XeAssignmentInExpressionScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 21:39'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo ());
		fdef: #(int foo ())
			body: [ 
					writer
						<< 'int x';
						if: '(x = 9 + 1) == 10' then: [ writer return: '1' ];
						return: '0' ]! !

!XeAssignmentInExpressionScenario methodsFor: 'c code' stamp: 'BernardoContreras 7/7/2012 02:08'!
foo
	<returnType: #int>
	<var: #x type: #int>
	| x |
	(x := 9 + 1) = 10
		ifTrue: [ ^ 1 ].
	^ 0! !

XeObject subclass: #XeAssignmentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Operators'!

!XeAssignmentScenario commentStamp: 'BernardoContreras 6/9/2012 00:57' prior: 0!
variable := expression 
==> 
variable = expression


!

!XeAssignmentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 21:39'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(void foo ());
		fdef: #(void foo ())
			body: [ 
					writer
						<< 'int x';
						<< 'x = 10';
						return ]! !

!XeAssignmentScenario methodsFor: 'c code' stamp: 'BernardoContreras 6/9/2012 00:56'!
foo
	<returnType: #void>
	<var: #x type: #int>
	| x |
	x := 10.

	! !

XeObject subclass: #XeBlockTemporariesScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Temporaries'!

!XeBlockTemporariesScenario commentStamp: 'BernardoContreras 6/8/2012 21:18' prior: 0!
[ |x y | ]

==>

{
	type x;
	type y;
}!

!XeBlockTemporariesScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 21:39'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo ());
		fdef: #(int foo ())
			body: [ 
					writer
						if: '1'
						then: [ 
							writer
								<< 'int x';
								<< 'void y';
								return: '1' ].
					writer return: '0' ]! !

!XeBlockTemporariesScenario methodsFor: 'c code' stamp: 'BernardoContreras 6/8/2012 22:37'!
foo
	<returnType: #int>
	<var: #x type: #int>
	true
		ifTrue: [ 
			| x y |
			^ 1 ].
	^ 0! !

XeObject subclass: #XeCmdArgScenario
	uses: XeDefineOnCG + XeTArgsMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Struct'!

XeCmdArgScenario class
	uses: XeDefineOnCG classTrait + XeTArgsMain classTrait
	instanceVariableNames: ''!

!XeCmdArgScenario class methodsFor: 'translation' stamp: 'BernardoContreras 7/29/2012 23:44'!
defineOn: cg
	"define yourself on the code generator"
	cg addClass: XeCmdArg

	! !

!XeCmdArgScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/22/2012 23:34'!
expected
	| expected struct |
	struct := XeCmdArg asString.
	expected := XeExpected new.
	expected
		<<< 'typedef struct ';
		openBrace;
		<< 'int size';
		<< 'char * * values'.
	expected
		decrementIndentation;
		<< ('} ' , struct);
		cr.
	expected functionPrototypesComment.
	expected
		<< 'int mainEntry(XeCmdArg args)';
		<< ('int ' , struct , '_size(' , struct , ' self)');
		<< ('void ' , struct , '_size(' , struct , ' self, int aSmallInteger)');
		<< ('char * * ' , struct , '_values(' , struct , ' self)');
		<< ('void ' , struct , '_values(' , struct , ' self, char * * anArray)').
	expected
		<<< 'int main(int argc, char * * argv)';
		openBrace;
		<< ('return mainEntry((' , struct , '_newForand(argc, argv)))');
		closeBrace.
	expected
		<<< 'int mainEntry(XeCmdArg args)';
		openBrace;
		<< 'return 0';
		closeBrace.
	expected
		<<< ('int ' , struct , '_size(' , struct , ' self)');
		openBrace;
		<< 'return self.size';
		closeBrace.
	expected
		<<< ('void ' , struct , '_size(' , struct , ' self, int aSmallInteger)');
		openBrace;
		<< 'self.size = aSmallInteger';
		<< 'return';
		closeBrace.
	expected
		<<< ('char * * ' , struct , '_values(' , struct , ' self)');
		openBrace;
		<< 'return self.values';
		closeBrace.
	expected
		<<< ('void ' , struct , '_values(' , struct , ' self, char * * anArray)');
		openBrace;
		<< 'self.values = anArray';
		<< 'return';
		closeBrace.
	^ expected! !

!XeCmdArgScenario methodsFor: 'main' stamp: 'BernardoContreras 8/21/2012 19:39'!
mainEntry: args
	<returnType: #int>
	<var: #args type: #XeCmdArg>
	^ 0! !

XeObject subclass: #XeDoNotTranslateScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeDoNotTranslateScenario commentStamp: '<historical>' prior: 0!
foo
  <doNotTranslate>

==>
!

!XeDoNotTranslateScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/25/2012 16:39'!
expectedOn: writer
	writer functionPrototypesComment! !

!XeDoNotTranslateScenario methodsFor: 'c code' stamp: 'BernardoContreras 6/18/2012 20:58'!
foo
	<doNotTranslate>
	! !

XeObject subclass: #XeDoWhileFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-While'!

!XeDoWhileFalseScenario commentStamp: 'BernardoContreras 5/12/2012 20:22' prior: 0!
[ stmt. ] doWhileFalse: [ stmt2. lastStmt. ]
==>
do {
	stmt;
		{	
		stmt2;
		if (lastStmt) break;
		}
	} while (1);
 
!

!XeDoWhileFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/22/2012 23:55'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void)'.
	expected
		<<< 'void foo(void)';
		openBrace.
	expected
		<<< 'do ';
		openBrace;
		<< '2'.
	expected
		incrementIndentation;
		<<< '{';
		cr.
	expected
		<< 'if (0) break';
		closeBrace;
		decrementIndentation.
	expected << '} while (1)'.
	expected
		<< 'return';
		closeBrace.
	^ expected! !

!XeDoWhileFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:26'!
foo
	<returnType: #void>
	[ 2 ] doWhileFalse: [ false ]
 ! !

XeObject subclass: #XeDoWhileTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-While'!

!XeDoWhileTrueScenario commentStamp: 'BernardoContreras 5/12/2012 20:22' prior: 0!
[ stmt. ] doWhileTrue: [ stmt2. lastStmt. ]
==>
do {
	stmt;
		{	
		stmt2;
		if (!!(lastStmt)) break;
		}
	} while (1);
 
!

!XeDoWhileTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/23/2012 00:02'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void)'.
	expected
		<<< 'void foo(void)';
		openBrace.
	expected
		<<< 'do ';
		openBrace.
	expected << '2'.
	expected
		incrementIndentation;
		<<< '{';
		cr;
		<< 'if (!!(1)) break';
		closeBrace.
	expected
		decrementIndentation;
		<< '} while (1)'.
	expected
		<< 'return';
		closeBrace.
	^ expected! !

!XeDoWhileTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:26'!
foo
	<returnType: #void>
	[ 2 ] doWhileTrue: [ true ]
 ! !

XeObject subclass: #XeFunctionCallAnotherFunctionScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionCallAnotherFunctionScenario commentStamp: '<historical>' prior: 0!
foo: x
    ^ self bar: x
==>
foo(x){
	return bar(x);
}!

!XeFunctionCallAnotherFunctionScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 21:36'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int bar (int y));
		fdecl: #(int foo (int x)).
	writer fdef: #(int bar (int y)) body: [ writer return: 'y + 1' ].
	writer fdef: #(int foo (int x)) body: [ writer return: 'bar(x)' ]! !

!XeFunctionCallAnotherFunctionScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/8/2012 00:42'!
bar: y
	<returnType: #int>
	<var: #y type: #int>
	^ y + 1! !

!XeFunctionCallAnotherFunctionScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/8/2012 00:41'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	^ self bar: x! !

XeObject subclass: #XeFunctionCallAnotherFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario commentStamp: '<historical>' prior: 0!
foo: x
    ^ self bar: x and: 5
==>
foo(x){
	return barand(x, 5);
}!

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 23:00'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int barand (int z int y));
		fdecl: #(int foo (int x)).
	writer fdef: #(int barand (int z int y)) body: [ writer return: 'y + z' ].
	writer fdef: #(int foo (int x)) body: [ writer return: 'barand(x, 5)' ]! !

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/9/2012 04:18'!
bar: z and: y
	<returnType: #int>
	<var: #z type: #int>
	<var: #y type: #int>
	^ y + z! !

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/9/2012 04:19'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	^ self bar: x and: 5! !

XeObject subclass: #XeFunctionThatReturnsZeroScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionThatReturnsZeroScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function that returns zero
!

!XeFunctionThatReturnsZeroScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 23:57'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo ());
		fdef: #(int foo ()) body: [ writer return: '0' ]! !

!XeFunctionThatReturnsZeroScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 18:49'!
foo
	<returnType: #int>
	^ 0
		
! !

XeObject subclass: #XeFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionWhenReturnTypeIsIntegerScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function when return type is integer.
!

!XeFunctionWhenReturnTypeIsIntegerScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/28/2012 18:17'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo ());
		fdef: #(int foo ()) body: [  ]! !

!XeFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

XeObject subclass: #XeFunctionWithAnotherNameScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionWithAnotherNameScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/28/2012 18:44'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int main #(int x));
		fdef: #(int main #(int x)) body: [  ]! !

!XeFunctionWithAnotherNameScenario methodsFor: 'c code' stamp: 'BernardoContreras 7/28/2012 19:53'!
foo: x
	<cFunctionName: 'main'>
	<returnType: #int>
	<var: #x type: #int>
	! !

XeObject subclass: #XeFunctionWithDefaultReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionWithDefaultReturnTypeScenario commentStamp: 'BernardoContreras 4/5/2012 15:19' prior: 0!
A function with a default return type.
!

!XeFunctionWithDefaultReturnTypeScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/28/2012 18:52'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo ());
		fdef: #(int foo ()) body: [  ]! !

!XeFunctionWithDefaultReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

XeObject subclass: #XeFunctionWithOneArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionWithOneArgumentScenario commentStamp: '<historical>' prior: 0!
foo: x

==>
int foo(sqInt x){
}
!

!XeFunctionWithOneArgumentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/28/2012 23:48'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo #(void x));
		fdef: #(int foo #(void x)) body: [  ]! !

!XeFunctionWithOneArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/2/2012 01:57'!
foo: x
	<returnType: #int>
! !

XeObject subclass: #XeFunctionWithOneIntegerArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionWithOneIntegerArgumentScenario commentStamp: '<historical>' prior: 0!
foo: x

==>
int foo(int x){
}!

!XeFunctionWithOneIntegerArgumentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/28/2012 23:52'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo (int x));
		fdef: #(int foo (int x)) body: [  ]! !

!XeFunctionWithOneIntegerArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 16:05'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	! !

XeObject subclass: #XeFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeFunctionWithTwoArgumentsScenario commentStamp: '<historical>' prior: 0!
foo: x and: y

==>
int fooand(sqInt x, sqInt y){
}
	
!

!XeFunctionWithTwoArgumentsScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/28/2012 23:56'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int fooand (void x void y));
		fdef: #(int fooand (void x void y)) body: [  ]! !

!XeFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/13/2012 00:15'!
foo: x and: y
	<returnType: #int>
	! !

XeObject subclass: #XeIfFalseAsArgumentInFunctionCallScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeIfFalseAsArgumentInFunctionCallScenario commentStamp: 'BernardoContreras 6/9/2012 19:26' prior: 0!
self bar: (condition ifFalse: [ stmts. lastStmt. ])
==>
bar( ( (!!(condition) ? lastStmt : 0) ) )
!

!XeIfFalseAsArgumentInFunctionCallScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/29/2012 19:39'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(#int #bar #(#int #y));
		fdecl: #(#int #foo #()).
	writer fdef: #(#int #bar #(#int #y)) body: [ writer return: 'y + 1' ].
	writer fdef: #(#int #foo #()) body: [ writer return: 'bar(((!!(0) ? 2 : 0)))' ]! !

!XeIfFalseAsArgumentInFunctionCallScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/25/2012 19:02'!
bar: y
	<returnType: #int>
	<var: #y type: #int>
	^ y + 1! !

!XeIfFalseAsArgumentInFunctionCallScenario methodsFor: 'c code' stamp: 'BernardoContreras 6/9/2012 19:18'!
foo
	<returnType: #int>
	^ self
		bar:
			(false
				ifFalse: [ 2 ])! !

XeObject subclass: #XeIfFalseAsArgumentInReturnScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeIfFalseAsArgumentInReturnScenario commentStamp: '<historical>' prior: 0!
^ condition ifFalse: [ stmts. lastStmt. ]
==>
 return (!!(condition) ? lastStmt : 0)
!

!XeIfFalseAsArgumentInReturnScenario class methodsFor: 'testing' stamp: 'BernardoContreras 9/2/2012 03:13'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo ());
		fdef: #(int foo ()) body: [ writer return: '(!!(0) ? 2 : 0)' ]! !

!XeIfFalseAsArgumentInReturnScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/16/2012 22:45'!
foo
	<returnType: #int>
	^ false
		ifFalse: [ 2 ]! !

XeObject subclass: #XeIfFalseIfTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeIfFalseIfTrueScenario commentStamp: '<historical>' prior: 0!
condition 
	ifFalse: [ FalseStmts ]
	ifTrue: [ TrueStmts ]
==>
if (condition){
	FalseStmts
} else {
	TrueStmts
}!

!XeIfFalseIfTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 9/2/2012 00:42'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(void foo ()).
	writer
		fdef: #(void foo ())
		body: [ 
			writer if: '!!(1)' then: [ writer << '21' ] else: [ writer << '22' ].
			writer return ]! !

!XeIfFalseIfTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:21'!
foo
	<returnType: #void>
	true
		ifFalse: [ 21 ]
		ifTrue: [ 22 ]! !

XeObject subclass: #XeIfFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeIfFalseScenario commentStamp: 'BernardoContreras 5/12/2012 01:55' prior: 0!
condition ifFalse: [ stmts. ]
==>
if (!!(condition)){
	stmts;
}
!

!XeIfFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 9/2/2012 18:01'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo ()).
	writer
		fdef: #(int foo ())
		body: [ 
			writer
				if: '!!(0)' then: [ writer << '0' ];
				return: '1' ]! !

!XeIfFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 6/3/2012 16:42'!
foo
	<returnType: #int>
	false
		ifFalse: [ 0 ].
	^ 1! !

XeObject subclass: #XeIfTrueAsArgumentInFunctionCallScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeIfTrueAsArgumentInFunctionCallScenario commentStamp: 'BernardoContreras 6/9/2012 19:27' prior: 0!
self bar: (condition ifTrue: [ stmts. lastStmt. ])
==>
bar( ( (condition ? lastStmt : 0) ) )

!

!XeIfTrueAsArgumentInFunctionCallScenario class methodsFor: 'testing' stamp: 'BernardoContreras 9/2/2012 18:16'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int bar (int y));
		fdecl: #(int foo ()).
	writer fdef: #(int bar (int y)) body: [ writer return: 'y + 1' ].
	writer fdef: #(int foo ()) body: [ writer return: 'bar(((0 ? 2 : 0)))' ]! !

!XeIfTrueAsArgumentInFunctionCallScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/25/2012 19:56'!
bar: y
	<returnType: #int>
	<var: #y type: #int>
	^ y + 1! !

!XeIfTrueAsArgumentInFunctionCallScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/25/2012 19:57'!
foo
	<returnType: #int>
    	^ self bar:  ( false ifTrue: [ 2 ] )! !

XeObject subclass: #XeIfTrueAsArgumentInReturnScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeIfTrueAsArgumentInReturnScenario commentStamp: '<historical>' prior: 0!
^ condition ifTrue: [ stmts. lastStmt. ]
==>
return  (condition ? lastStmt : 0)
!

!XeIfTrueAsArgumentInReturnScenario class methodsFor: 'testing' stamp: 'BernardoContreras 9/2/2012 18:37'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(#int #foo #()).
	writer fdef: #(#int #foo #()) body: [ writer return: '(1 ? 2 : 0)' ]! !

!XeIfTrueAsArgumentInReturnScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/20/2012 16:41'!
foo
	<returnType: #int>
	^ true
		ifTrue: [ 2 ]! !

XeObject subclass: #XeIfTrueIfFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeIfTrueIfFalseScenario commentStamp: '<historical>' prior: 0!
condition 
	ifTrue: [ TrueStmts ]
	ifFalse: [ FalseStmts ]
==>
if (condition){
	TrueStmts
} else {
	FalseStmts
}
!

!XeIfTrueIfFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/22/2012 23:08'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void)'.
	expected
		<<< 'void foo(void)';
		openBrace.
	expected
		<<< 'if (1) ';
		openBrace;
		<< '21';
		decrementIndentation.
	expected
		<<< '} else ';
		openBrace;
		<< '22';
		closeBrace.
	expected
		<< 'return';
		closeBrace.
	^ expected! !

!XeIfTrueIfFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:20'!
foo
	<returnType: #void>
	true
		ifTrue: [ 21 ]
		ifFalse: [ 22 ]! !

XeObject subclass: #XeIfTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeIfTrueScenario commentStamp: '<historical>' prior: 0!
condition ifTrue: [ stmts ]
==>
if (condition){
	stmts
}
!

!XeIfTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/22/2012 23:11'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void)'.
	expected
		<<< 'int foo(void)';
		openBrace.
	expected
		<<< 'if (1) ';
		openBrace;
		<< '0';
		closeBrace.
	expected
		<< 'return 1';
		closeBrace.
	^ expected! !

!XeIfTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 6/3/2012 16:44'!
foo
	<returnType: #int>
	true
		ifTrue: [ 0 ].
	^ 1! !

XeObject subclass: #XeLearningScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeLearningScenario commentStamp: 'BernardoContreras 8/24/2012 20:34' prior: 0!
a place to study, practice, learn.
XeScenarioBrowser browse: self  

!

!XeLearningScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 21:40'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(int foo ());
		fdef: #(int foo ())
			body: [ 
					writer
						if: '1' then: [ writer return: '(-2 + 1) * 3' ];
						return: '0' ]! !

!XeLearningScenario methodsFor: 'c code' stamp: 'BernardoContreras 8/19/2012 04:07'!
foo
	<returnType: #int>
	true
		ifTrue: [ ^  2 negated + 1 * 3  ].
	^ 0! !

XeObject subclass: #XeMethodTemporariesScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Temporaries'!

!XeMethodTemporariesScenario commentStamp: '<historical>' prior: 0!
foo
   | x y |

==>
void foo(void){
	type x;
	type y;
}
!

!XeMethodTemporariesScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 21:40'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdecl: #(void foo ());
		fdef: #(void foo ())
			body: [ 
					writer
						<< 'int x';
						<< 'void y' ]! !

!XeMethodTemporariesScenario methodsFor: 'c code' stamp: 'BernardoContreras 6/8/2012 22:38'!
foo
	<returnType: #void>
	<var: #x type: #int>
	| x y |
	! !

XeObject subclass: #XeNoFunctionPrototypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeNoFunctionPrototypeScenario commentStamp: 'BernardoContreras 6/20/2012 17:47' prior: 0!
foo
	<noFunctionPrototype>
	
==>
no function prototype just the body.
int foo(void){
}
!

!XeNoFunctionPrototypeScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/27/2012 21:40'!
expectedOn: writer
	writer
		functionPrototypesComment;
		fdef: #(int foo ()) body: [  ]! !

!XeNoFunctionPrototypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 6/19/2012 22:34'!
foo
	<noFunctionPrototype>
	! !

XeObject subclass: #XeSemanticObject
	instanceVariableNames: 'instVar'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'Xenon-Tests-Semantic'!

!XeSemanticObject commentStamp: 'BernardoContreras 8/5/2012 17:04' prior: 0!
a subject of testing. used by XeSemanticTest!

XeObject subclass: #XeSimpleStructScenario
	instanceVariableNames: 'instVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Struct'!

!XeSimpleStructScenario commentStamp: '<historical>' prior: 0!
a simple structure
==>
struct {
   type instarVar
}
!

!XeSimpleStructScenario class methodsFor: 'translation' stamp: 'BernardoContreras 8/7/2012 00:16'!
describeOn: descriptor
	descriptor beStruct.
	descriptor instVar: 'instVar' type: #int.! !

!XeSimpleStructScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/22/2012 23:39'!
expected
	| expected |
	expected := XeExpected new.
	expected
		<<< 'typedef struct ';
		openBrace;
		<< 'int instVar'.
	expected
		decrementIndentation;
		<< ('} ' , self asString).
	expected functionPrototypesComment.
	expected << ('int ' , self asString , '_fooand(' , self asString , ' self, void x, void y)').
	expected
		<<< ('int ' , self asString , '_fooand(' , self asString , ' self, void x, void y)');
		openBrace;
		<< 'return self.instVar';
		closeBrace.
	^ expected! !

!XeSimpleStructScenario methodsFor: 'c code' stamp: 'BernardoContreras 7/29/2012 02:00'!
foo: x and: y
	<returnType: #int>
	^ instVar 
	! !

XeObject subclass: #XeWhileFalseDoScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-While'!

!XeWhileFalseDoScenario commentStamp: 'BernardoContreras 5/11/2012 22:49' prior: 0!
[ stmt.
  lastStmt ] whileFalse: [ stmt2. ]
==>
while (1){
	{	
		stmt;
		if (lastStmt) break;
	}
	stmt2;
}!

!XeWhileFalseDoScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/23/2012 00:08'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void)'.
	expected
		<<< 'void foo(void)';
		openBrace.
	expected
		<<< 'while (1) ';
		openBrace.
	expected
		incrementIndentation;
		<<< '{';
		cr;
		<< 'if (0) break';
		closeBrace.
	expected
		<< '2';
		decrementIndentation;
		<<< '}';
		cr.
	expected
		<< 'return';
		closeBrace.
	^ expected! !

!XeWhileFalseDoScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:28'!
foo
	<returnType: #void>
	[ false ] whileFalse: [ 2 ]
 ! !

XeObject subclass: #XeWhileFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-While'!

!XeWhileFalseScenario commentStamp: 'BernardoContreras 5/12/2012 01:37' prior: 0!
[ stmt.
  lastStmt ] whileFalse
==>
while (1){
	stmt;
	if (lastStmt) break;
}!

!XeWhileFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/23/2012 00:11'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void)'.
	expected
		<<< 'void foo(void)';
		openBrace.
	expected
		<<< 'while (1) ';
		openBrace;
		<< 'if (1) break';
		closeBrace.
	expected
		<< 'return';
		closeBrace.
	^ expected! !

!XeWhileFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 01:49'!
foo
	<returnType: #void>
	[ true ] whileFalse! !

XeObject subclass: #XeWhileTrueDoScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-While'!

!XeWhileTrueDoScenario commentStamp: 'BernardoContreras 5/11/2012 22:43' prior: 0!
[ stmt.
  lastStmt ] whileTrue: [ stmt2. ]
==>
while (1){
	{	
		stmt;
		if (!!(lastStmt)) break;
	}
	stmt2;
}!

!XeWhileTrueDoScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/23/2012 00:21'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void)'.
	expected
		<<< 'void foo(void)';
		openBrace.
	expected
		<<< 'while (1) ';
		openBrace;
		incrementIndentation.
	expected
		<<< '{';
		cr.
	expected
		<< 'if (!!(1)) break';
		closeBrace.
	expected
		<< '2';
		closeBrace.
	expected
		<< 'return';
		closeBrace.
	^ expected! !

!XeWhileTrueDoScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:28'!
foo
	<returnType: #void>
	[ true ] whileTrue: [ 2 ]
 ! !

XeObject subclass: #XeWhileTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-While'!

!XeWhileTrueScenario commentStamp: 'BernardoContreras 5/11/2012 22:44' prior: 0!
[ stmt.
  lastStmt ] whileTrue
==>
while (1){
	stmt;
	if (!!(lastStmt)) break;
}
!

!XeWhileTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 8/23/2012 00:35'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void)'.
	expected
		<<< 'void foo(void)';
		openBrace.
	expected
		<<< 'while (1) ';
		openBrace;
		<< 'if (!!(1)) break';
		closeBrace.
	expected
		<< 'return';
		closeBrace.
	^ expected! !

!XeWhileTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 23:44'!
foo
	<returnType: #void>
	[ true ] whileTrue! !

TestCase subclass: #XeAbstractTest
	instanceVariableNames: 'cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeAbstractTest class methodsFor: 'accessing' stamp: 'BernardoContreras 5/27/2012 18:05'!
packageNamesUnderTest
	^ #('Xenon-Core')! !

!XeAbstractTest methodsFor: 'convenience' stamp: 'BernardoContreras 8/5/2012 17:00'!
assert: expected equalsTranslationOf: aExpression
	" assert expected equals the translation of a expression"

	| actualString |
	actualString := cg translateExpression: aExpression in: XeObject.
	self assert: expected = actualString
	! !

!XeAbstractTest methodsFor: 'convenience' stamp: 'BernardoContreras 8/24/2012 23:14'!
assertTranslationOf2: aClass
	" assert expected equals the translation of aClass"

	| expectedString actualString writer |
	writer := XeExpected new.
	aClass expectedOn: writer.
	expectedString := writer contents.
	cg addClass: aClass.
	actualString := cg codeString.
	self assert: expectedString = actualString description: (self browse: aClass)! !

!XeAbstractTest methodsFor: 'convenience' stamp: 'BernardoContreras 8/22/2012 19:10'!
assertTranslationOf: aClass
	" assert expected equals the translation of aClass"

	| expectedString actualString |
	expectedString := aClass expected contents.
	cg addClass: aClass.
	actualString := cg codeString.
	self assert: expectedString = actualString description: (self browse: aClass)! !

!XeAbstractTest methodsFor: 'convenience' stamp: 'BernardoContreras 5/25/2012 21:25'!
browse: aClass
	"browse this scenario in order to know what when wrong"

	^ XeScenarioBrowser asString , ' browse: ' , aClass asString! !

!XeAbstractTest methodsFor: 'running' stamp: 'BernardoContreras 4/11/2012 02:23'!
setUp
	cg := XeCodeGenerator new! !

XeAbstractTest subclass: #XeCLiteralValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeCLiteralValueTest commentStamp: 'BernardoContreras 4/11/2012 19:47' prior: 0!
To test the translation of objects to a C literal value.
!

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/15/2012 23:22'!
testCharTranslateToQuotedChar
	self assert: '''' , 'e' , '''' equalsTranslationOf: '$e'
	! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/15/2012 23:23'!
testFalseTranslateToZero
	self assert: '0' equalsTranslationOf: 'false'
	! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/16/2012 01:40'!
testFloatTranslateToDouble
	self assert: '3.478' equalsTranslationOf: '3.478'! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/20/2012 20:13'!
testLargeNegativeIntegerTranslateToLongLongWhenThereAreEightBytesPerWord
	cg beEightBytesPerWord.
	self assert: '-2147483649LL' equalsTranslationOf: '-2147483649'! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/20/2012 20:20'!
testLargeNegativeIntegerTranslateToLongWhenThereAreFourBytesPerWord
	cg beFourBytesPerWord.
	self assert: '-2147483649L' equalsTranslationOf: '-2147483649'! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/16/2012 23:07'!
testLargePositiveIntegerTranslateToUnsignedLongLongWhenThereAreEightBytesPerWord
	cg beEightBytesPerWord.
	self assert: '2147483649ULL' equalsTranslationOf: '2147483649'! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/16/2012 23:03'!
testLargePositiveIntegerTranslateToUnsignedLongWhenThereAreFourBytesPerWord
	self assert: '2147483649UL' equalsTranslationOf: '2147483649'! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/20/2012 21:30'!
testLiteralArrayTranslateToArray
	self assert: '[1, 2]' equalsTranslationOf: '#(1 2)'
	! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 8/9/2012 19:09'!
testNilTranslateToNULL
	self assert: 'NULL' equalsTranslationOf: 'nil' 
	! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/20/2012 21:30'!
testRuntimeArrayTranslateToArray
	self assert: '[1, 2]' equalsTranslationOf: '{1. 2}'
	! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/16/2012 23:08'!
testSmallIntegerTranslateToInteger
	self assert: '3' equalsTranslationOf: '3'! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/16/2012 00:54'!
testStringTranslateToQuotedString
	self assert: '"' , 'aString' , '"' equalsTranslationOf: '''aString'''! !

!XeCLiteralValueTest methodsFor: 'tests' stamp: 'BernardoContreras 6/16/2012 01:06'!
testTrueTranslateToZero
	self assert: '1' equalsTranslationOf: 'true'! !

XeAbstractTest subclass: #XeDoNotTranslateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeDoNotTranslateTest methodsFor: 'tests' stamp: 'BernardoContreras 8/25/2012 16:41'!
testAddHeaderFileOnCG
	self assertTranslationOf2: XeAddHeaderFileOnCGScenario 
	! !

!XeDoNotTranslateTest methodsFor: 'tests' stamp: 'BernardoContreras 8/25/2012 16:37'!
testDoNotTranslate
	self assertTranslationOf2: XeDoNotTranslateScenario ! !

!XeDoNotTranslateTest methodsFor: 'tests' stamp: 'BernardoContreras 8/24/2012 23:22'!
testNoFunctionPrototype
	self assertTranslationOf2: XeNoFunctionPrototypeScenario! !

XeAbstractTest subclass: #XeLearningTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeLearningTest commentStamp: '<historical>' prior: 0!
a place to study, practice, learn !

!XeLearningTest methodsFor: 'tests' stamp: 'BernardoContreras 8/24/2012 23:11'!
testYourKnowledgeAboutTranslationAndCouldFail
	self assertTranslationOf2: XeLearningScenario 
	! !

XeAbstractTest subclass: #XeSemanticTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Semantic'!

!XeSemanticTest commentStamp: 'BernardoContreras 5/25/2012 18:17' prior: 0!
stolen from AST-Semantic!

!XeSemanticTest class methodsFor: 'accessing' stamp: 'BernardoContreras 5/25/2012 18:23'!
packageNamesUnderTest
	^ #('Xenon-Core')! !

!XeSemanticTest methodsFor: 'utilities' stamp: 'BernardoContreras 8/5/2012 17:05'!
parseExpression: aString
	^ (RBParser parseExpression: aString)
		xeAnnotateInClass: XeSemanticObject with: cg;
		yourself! !

!XeSemanticTest methodsFor: 'utilities' stamp: 'BernardoContreras 8/5/2012 17:06'!
parseMethod: aString
	^ (RBParser parseMethod: aString)
		xeAnnotateInClass: XeSemanticObject with: cg;
		yourself! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 6/16/2012 15:22'!
testAccessors
	| tree binding |
	tree := self parseExpression: '| var | var'.
	binding := tree xeScope bindingOf: 'var'.
	self assert: binding node = tree temporaries first.
	self assert: binding accessors size = 1.
	self assert: binding accessors first = tree statements first.
	self assert: binding readers isEmpty.
	self assert: binding writers isEmpty! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:24'!
testBlockArgumentBinding
	| tree binding |
	tree := self parseExpression: '[ :arg | ]'.
	binding := tree arguments first xeVariableBinding.
	
	self assert: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self deny: binding isAccessed.
	self assert: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'arg'.
	self assert: binding printString isString.
	self assert: binding node = tree arguments first.
	self assert: binding scope = tree xeScope! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 6/16/2012 15:24'!
testBlockScope
	| tree scope |
	tree := self parseExpression: '[ :arg | | tmp | ]'.
	scope := tree xeScope.
	
	self assert: scope isBlockScope.
	self deny: scope isLiteralScope.
	self deny: scope isMethodScope.
	self deny: scope isRootScope.
	self deny: scope isVariableScope.
	
	self assert: scope node = tree.
	
	self assert: (scope lookup: 'arg') isArgumentBinding.
	self assert: (scope lookup: 'arg') scope = scope.
	self assert: (scope lookup: 'arg') name = 'arg'.

	self assert: (scope lookup: 'tmp') isTemporaryBinding.
	self assert: (scope lookup: 'tmp') scope = scope.
	self assert: (scope lookup: 'tmp') name = 'tmp'.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:24'!
testBlockTemporaryBinding
	| tree binding |
	tree := self parseExpression: '[ | tmp | ]'.
	binding := tree body temporaries first xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self assert: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self deny: binding isAccessed.
	self assert: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'tmp'.
	self assert: binding printString isString.
	self assert: binding node = tree body temporaries first.
	self assert: binding scope = tree xeScope! !

!XeSemanticTest methodsFor: 'testing-fixtures' stamp: 'BernardoContreras 5/25/2012 17:49'!
testCascadeReceiver
	| tree receiver receiver1 receiver2 |
	tree := self parseExpression: 'self foo; bar'.
	receiver := tree receiver.
	receiver1 := tree messages first receiver.
	receiver2 := tree messages last receiver.
	
	self assert: receiver xeVariableBinding = receiver1 xeVariableBinding.
	self assert: receiver xeVariableBinding = receiver2 xeVariableBinding! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 8/5/2012 17:07'!
testClassVariableBinding
	| tree binding |
	tree := self parseExpression: 'ClassVar'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self assert: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'ClassVar'.
	self assert: binding printString isString.
	self assert: binding binding = (XeSemanticObject bindingOf: 'ClassVar').
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:25'!
testGlobalVariableBinding
	| tree binding |
	tree := self parseExpression: self class name.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self assert: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = self class name.
	self assert: binding printString isString.
	self assert: binding binding = (self class bindingOf: self class name).
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 8/5/2012 17:06'!
testInstanceVariableBinding
	| tree binding |
	tree := self parseExpression: 'instVar'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self assert: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'instVar'.
	self assert: binding printString isString.
	self assert: binding index = (XeSemanticObject allInstVarNames indexOf: 'instVar').
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 6/16/2012 15:28'!
testLiteralScope
	| scope literals |
	scope := RBLiteralScope
		owner: RBRootScope new
		class: RBMessageNode.
	
	self deny: scope isBlockScope.
	self assert: scope isLiteralScope.
	self deny: scope isMethodScope.
	self deny: scope isRootScope.
	self deny: scope isVariableScope.
	
	self assert: scope theClass = RBMessageNode.
	
	literals := OrderedCollection new.
	literals addAll: (RBMessageNode allClassVarNames).
	literals addAll: (RBProgramNode allSubclasses collect: [ :each | each name ]).
	literals do: [ :name |
		self assert: (scope lookup: name) isLiteralBinding.
		self assert: (scope lookup: name) scope = scope.
		self assert: (scope lookup: name) name = name ].
	
	self assert: (scope lookup: 'self') scope = scope owner.
	self assert: (scope lookup: 'super') scope = scope owner.
	self assert: (scope lookup: 'thisContext') scope = scope owner.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:29'!
testMethodArgumentBinding
	| tree binding |
	tree := self parseMethod: 'foo: arg'.
	binding := tree arguments first xeVariableBinding.
	
	self assert: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self deny: binding isAccessed.
	self assert: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'arg'.
	self assert: binding printString isString.
	self assert: binding node = tree arguments first.
	self assert: binding scope = tree xeScope! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 6/16/2012 15:30'!
testMethodScope
	| tree scope |
	tree := self parseMethod: 'foo: arg | tmp |'.
	scope := tree xeScope.
	
	self deny: scope isBlockScope.
	self deny: scope isLiteralScope.
	self assert: scope isMethodScope.
	self deny: scope isRootScope.
	self deny: scope isVariableScope.
	
	self assert: scope node = tree.
	
	self assert: (scope lookup: 'arg') isArgumentBinding.
	self assert: (scope lookup: 'arg') scope = scope.
	self assert: (scope lookup: 'arg') name = 'arg'.

	self assert: (scope lookup: 'tmp') isTemporaryBinding.
	self assert: (scope lookup: 'tmp') scope = scope.
	self assert: (scope lookup: 'tmp') name = 'tmp'.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:30'!
testMethodTemporaryBinding
	| tree binding |
	tree := self parseMethod: 'foo | tmp |'.
	binding := tree body temporaries first xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self assert: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self deny: binding isAccessed.
	self assert: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'tmp'.
	self assert: binding printString isString.
	self assert: binding node = tree body temporaries first.
	self assert: binding scope = tree xeScope! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 6/16/2012 15:17'!
testMissing
	| tree |
	tree := self parseExpression: 'a'.

	self 
		should: [ RBVariableNode new xeScope ]
		raise: XeSemanticAnnotationMissing.
	self
		shouldnt: [ tree xeScope ]
		raise: XeSemanticAnnotationMissing.
		
	self
		should: [ RBVariableNode new xeVariableBinding ]
		raise: XeSemanticAnnotationMissing.
	self
		shouldnt: [ tree xeVariableBinding ]
		raise: XeSemanticAnnotationMissing.
		
	self deny: RBVariableNode new hasVariableBinding.
	self assert: tree hasXeVariableBinding! !

!XeSemanticTest methodsFor: 'testing-fixtures' stamp: 'BernardoContreras 6/16/2012 15:31'!
testMultipleScopes
	| tree block1 variable1 block2 variable2 |
	tree := self parseExpression: '[ :a | a ]. [ | a | a ]'.
	block1 := tree statements first.
	variable1 := block1 arguments first.
	block2 := tree statements last.
	variable2 := block2 body temporaries first.
	
	self deny: variable1 xeVariableBinding = variable2 xeVariableBinding.
	self assert: variable1 xeVariableBinding = block1 body statements first xeVariableBinding.
	
	self deny: variable2 xeVariableBinding = variable1 xeVariableBinding.
	self assert: variable2 xeVariableBinding = block2 body statements first xeVariableBinding.
	
	self assert: variable1 xeVariableBinding scope = block1 xeScope.
	self assert: variable2 xeVariableBinding scope = block2 xeScope.! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 6/16/2012 15:17'!
testReadWriter
	| tree binding |
	tree := self parseExpression: '| var | ^ var := 1'.
	binding := tree xeScope bindingOf: 'var'.
	self assert: binding node = tree temporaries first.
	self assert: binding accessors size = 1.
	self assert: binding accessors first = tree statements first value variable.
	self assert: binding readers size = 1.
	self assert: binding readers first = tree statements first value variable.
	self assert: binding writers size = 1.
	self assert: binding writers first = tree statements first value variable.! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 6/16/2012 15:17'!
testReader
	| tree binding |
	tree := self parseExpression: '| var | ^ var'.
	binding := tree xeScope bindingOf: 'var'.
	self assert: binding node = tree temporaries first.
	self assert: binding accessors size = 1.
	self assert: binding accessors first = tree statements first value.
	self assert: binding readers size = 1.
	self assert: binding readers first = tree statements first value.
	self assert: binding writers isEmpty! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 5/25/2012 16:45'!
testRootScope
	| scope |
	scope := RBRootScope new.
	
	self deny: scope isBlockScope.
	self deny: scope isLiteralScope.
	self deny: scope isMethodScope.
	self assert: scope isRootScope.
	self deny: scope isVariableScope.
	
	self assert: (scope lookup: 'self') isSelfBinding.
	self assert: (scope lookup: 'self') scope = scope.

	self assert: (scope lookup: 'super') isSuperBinding.
	self assert: (scope lookup: 'super') scope = scope.

	self assert: (scope lookup: 'thisContext') isContextBinding.
	self assert: (scope lookup: 'thisContext') scope = scope.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing-fixtures' stamp: 'BernardoContreras 5/25/2012 18:05'!
testShadowedVariables
	| tree variable1 variable2 variable3 variable4 |
	tree := self parseExpression: '| a | [ :a | a ]. a'.
	variable1 := tree temporaries first.
	variable2 := tree statements first arguments first.
	variable3 := tree statements first body statements first.
	variable4 := tree statements last.
	
	self deny: variable1 xeVariableBinding isShadowing.
	self assert: variable2 xeVariableBinding isShadowing.
	self assert: variable3 xeVariableBinding isShadowing.
	self deny: variable4 xeVariableBinding isShadowing.
	
	self assert: variable1 xeVariableBinding = variable4 xeVariableBinding.
	self deny: variable1 xeVariableBinding = variable3 xeVariableBinding.
	self deny: variable2 xeVariableBinding = variable4 xeVariableBinding.
	self assert: variable2 xeVariableBinding = variable3 xeVariableBinding.
	! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:32'!
testSpecialContextBinding
	| tree binding |
	tree := self parseExpression: 'thisContext'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self assert: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'thisContext'.
	self assert: binding printString isString.
	self deny: binding scope isNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:36'!
testSpecialSelfBinding
	| tree binding |
	tree := self parseExpression: 'self'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self assert: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'self'.
	self assert: binding printString isString.
	self deny: binding scope isNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:36'!
testSpecialSuperBinding
	| tree binding |
	tree := self parseExpression: 'super'.
	binding := tree xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self assert: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self assert: binding isReadonly.
	
	self assert: binding name = 'super'.
	self assert: binding printString isString.
	self deny: binding scope isNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:36'!
testUndeclaredBinding
	| tree binding |
	tree := self parseExpression: '[ undecl ]'.
	binding := tree body statements first xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self deny: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self assert: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'undecl'.
	self assert: binding printString isString.
	self assert: binding node = tree body statements first.
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-bindings' stamp: 'BernardoContreras 6/16/2012 15:39'!
testUndeclaredHandled
	| seen tree binding |
	seen := false.
	tree := [ self parseExpression: '[ undecl ]' ]
		on: XeUndeclaredVariableNotification
		do: [ :err |
			seen := true.
			err resume: (XeLiteralBinding binding: (err node name -> 123)) ].
	self assert: seen.
	binding := tree body statements first xeVariableBinding.
	
	self deny: binding isArgumentBinding.
	self deny: binding isContextBinding.
	self deny: binding isInstanceBinding.
	self assert: binding isLiteralBinding.
	self deny: binding isSelfBinding.
	self deny: binding isSuperBinding.
	self deny: binding isTemporaryBinding.
	self deny: binding isUndeclaredBinding.
	
	self assert: binding isAccessed.
	self deny: binding accessors isEmpty.	
	self deny: binding isRead.
	self assert: binding readers isEmpty.
	self deny: binding isWritten.
	self assert: binding writers isEmpty.
	self deny: binding isReadonly.
	
	self assert: binding name = 'undecl'.
	self assert: binding printString isString.
	self assert: binding binding key = 'undecl'.
	self assert: binding binding value = 123.
	self assert: binding scope notNil! !

!XeSemanticTest methodsFor: 'testing-scopes' stamp: 'BernardoContreras 5/25/2012 16:45'!
testVariableScope
	| scope |
	scope := RBVariableScope
		owner: RBRootScope new
		class: RBMessageNode.
	
	self deny: scope isBlockScope.
	self deny: scope isLiteralScope.
	self deny: scope isMethodScope.
	self deny: scope isRootScope.
	self assert: scope isVariableScope.
	
	self assert: scope theClass = RBMessageNode.
	
	RBMessageNode allInstVarNames keysAndValuesDo: [ :index :name |
		self assert: (scope lookup: name) isInstanceBinding.
		self assert: (scope lookup: name) scope = scope.
		self assert: (scope lookup: name) name = name.
		self assert: (scope lookup: name) index = index ].
	
	self assert: (scope lookup: 'self') scope = scope owner.
	self assert: (scope lookup: 'super') scope = scope owner.
	self assert: (scope lookup: 'thisContext') scope = scope owner.

	self should: [ scope lookup: 'something' ] raise: Error.
	self assert: (scope lookup: 'something' ifAbsent: [ #nothing ]) = #nothing ! !

!XeSemanticTest methodsFor: 'testing' stamp: 'BernardoContreras 6/16/2012 15:16'!
testWriter
	| tree binding |
	tree := self parseExpression: '| var | var := 1'.
	binding := tree xeScope bindingOf: 'var'.
	self assert: binding node = tree temporaries first.
	self assert: binding accessors size = 1.
	self assert: binding accessors first = tree statements first variable.
	self assert: binding readers isEmpty.
	self assert: binding writers size = 1.
	self assert: binding writers first = tree statements first variable! !

XeAbstractTest subclass: #XeTranslateFunctionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Function'!

!XeTranslateFunctionTest commentStamp: 'BernardoContreras 4/5/2012 15:12' prior: 0!
To test the translation of functions
!

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/27/2012 20:40'!
testTranslateFunctionCallAnotherFunction
	self assertTranslationOf2: XeFunctionCallAnotherFunctionScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/27/2012 22:47'!
testTranslateFunctionCallAnotherFunctionWithTwoArguments
	self assertTranslationOf2: XeFunctionCallAnotherFunctionWithTwoArgumentsScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/27/2012 23:53'!
testTranslateFunctionThatReturnsZero
	self assertTranslationOf2: XeFunctionThatReturnsZeroScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/28/2012 18:49'!
testTranslateFunctionWhenReturnTypeIsDefault
	self assertTranslationOf2: XeFunctionWithDefaultReturnTypeScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/28/2012 18:14'!
testTranslateFunctionWhenReturnTypeIsInteger
	self assertTranslationOf2: XeFunctionWhenReturnTypeIsIntegerScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/28/2012 18:29'!
testTranslateFunctionWithAnotherName
	self assertTranslationOf2: XeFunctionWithAnotherNameScenario 
	! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/28/2012 23:44'!
testTranslateFunctionWithOneArgument
	self assertTranslationOf2: XeFunctionWithOneArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/28/2012 23:48'!
testTranslateFunctionWithOneIntegerArgument
	self assertTranslationOf2: XeFunctionWithOneIntegerArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 8/28/2012 23:53'!
testTranslateFunctionWithTwoArguments
	self assertTranslationOf2: XeFunctionWithTwoArgumentsScenario! !

XeAbstractTest subclass: #XeTranslateIfStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-If'!

!XeTranslateIfStatementTest commentStamp: 'BernardoContreras 4/11/2012 02:33' prior: 0!
To test the translation of the if statement!

!XeTranslateIfStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 8/29/2012 19:26'!
testTranslateIfFalseAsArgumentInFunctionCallStatement
	self assertTranslationOf2: XeIfFalseAsArgumentInFunctionCallScenario ! !

!XeTranslateIfStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 9/1/2012 23:04'!
testTranslateIfFalseAsArgumentInReturnStatement
	self assertTranslationOf2: XeIfFalseAsArgumentInReturnScenario! !

!XeTranslateIfStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 9/1/2012 23:28'!
testTranslateIfFalseIfTrueStatement
	self assertTranslationOf2: XeIfFalseIfTrueScenario! !

!XeTranslateIfStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 9/2/2012 17:42'!
testTranslateIfFalseStatement
	self assertTranslationOf2: XeIfFalseScenario! !

!XeTranslateIfStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 9/2/2012 18:08'!
testTranslateIfTrueAsArgumentInFunctionCallStatement
	self assertTranslationOf2: XeIfTrueAsArgumentInFunctionCallScenario ! !

!XeTranslateIfStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 9/2/2012 18:31'!
testTranslateIfTrueAsArgumentInReturnStatement
	self assertTranslationOf2: XeIfTrueAsArgumentInReturnScenario! !

!XeTranslateIfStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 4/24/2012 23:44'!
testTranslateIfTrueIfFalseStatement
	self assertTranslationOf: XeIfTrueIfFalseScenario! !

!XeTranslateIfStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 4/12/2012 20:48'!
testTranslateIfTrueStatement
	self assertTranslationOf: XeIfTrueScenario! !

XeAbstractTest subclass: #XeTranslateOperatorsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Operators'!

!XeTranslateOperatorsTest commentStamp: 'BernardoContreras 6/8/2012 21:37' prior: 0!
To test the translation of operators
!

!XeTranslateOperatorsTest methodsFor: 'tests arithmetic operators' stamp: 'BernardoContreras 6/13/2012 00:04'!
testTranslateAddition
	self assert: '2 + 1' equalsTranslationOf: '2 + 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests arithmetic operators' stamp: 'BernardoContreras 6/13/2012 00:21'!
testTranslateAnotherDivision
	self assert: '1 // 2' equalsTranslationOf: '1 // 2'! !

!XeTranslateOperatorsTest methodsFor: 'tests assignment' stamp: 'BernardoContreras 8/25/2012 19:37'!
testTranslateAssignment
	self assertTranslationOf2: XeAssignmentScenario 
	! !

!XeTranslateOperatorsTest methodsFor: 'tests assignment' stamp: 'BernardoContreras 8/27/2012 20:09'!
testTranslateAssignmentInExpression
	self assertTranslationOf2: XeAssignmentInExpressionScenario! !

!XeTranslateOperatorsTest methodsFor: 'tests arithmetic operators' stamp: 'BernardoContreras 6/13/2012 00:05'!
testTranslateDivision
	self assert: '2 / 1' equalsTranslationOf: '2 / 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests comparison operators' stamp: 'BernardoContreras 6/9/2012 00:31'!
testTranslateEqual
	self assert: '2 == 1' equalsTranslationOf: '2 = 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests comparison operators' stamp: 'BernardoContreras 6/9/2012 00:32'!
testTranslateEqualEqual
	self assert: '2 == 1' equalsTranslationOf: '2 == 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests comparison operators' stamp: 'BernardoContreras 6/9/2012 00:28'!
testTranslateGreaterThan
	self assert: '2 > 1' equalsTranslationOf: '2 > 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests comparison operators' stamp: 'BernardoContreras 6/9/2012 00:30'!
testTranslateGreaterThanOrEqual
	self assert: '2 >= 1' equalsTranslationOf: '2 >= 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests bit shifting' stamp: 'BernardoContreras 6/14/2012 20:04'!
testTranslateLeftShiftOperator
	self assert: '47 << 1' equalsTranslationOf: '47 << 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests comparison operators' stamp: 'BernardoContreras 6/9/2012 00:29'!
testTranslateLessThan
	self assert: '2 < 1' equalsTranslationOf: '2 < 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests comparison operators' stamp: 'BernardoContreras 6/9/2012 00:30'!
testTranslateLessThanOrEqual
	self assert: '2 <= 1' equalsTranslationOf: '2 <= 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests logical operators' stamp: 'BernardoContreras 6/9/2012 20:10'!
testTranslateLogicalAnd
	self assert: '1 && 0' equalsTranslationOf: 'true & false'.
	self assert: '(1 && 0) && 1' equalsTranslationOf: 'true & false & true'! !

!XeTranslateOperatorsTest methodsFor: 'tests logical operators' stamp: 'BernardoContreras 6/9/2012 20:10'!
testTranslateLogicalOr
	self assert: '1 || 0' equalsTranslationOf: 'true | false'.
	self assert: '(1 || 0) || 1' equalsTranslationOf: 'true | false | true'! !

!XeTranslateOperatorsTest methodsFor: 'tests arithmetic operators' stamp: 'BernardoContreras 6/13/2012 00:21'!
testTranslateModularDivision
	self assert: '3 % 4' equalsTranslationOf: '3 \\ 4'! !

!XeTranslateOperatorsTest methodsFor: 'tests arithmetic operators' stamp: 'BernardoContreras 6/14/2012 20:14'!
testTranslateNegated
	self assert: '-2' equalsTranslationOf: '2 negated'! !

!XeTranslateOperatorsTest methodsFor: 'tests arithmetic operators' stamp: 'BernardoContreras 6/14/2012 20:14'!
testTranslateNegation
	self assert: '-2' equalsTranslationOf: '-2'! !

!XeTranslateOperatorsTest methodsFor: 'tests logical operators' stamp: 'BernardoContreras 6/9/2012 18:52'!
testTranslateNot
	self assert: '!!(1)' equalsTranslationOf: 'true not'.
	self assert: '!!(!!(1))' equalsTranslationOf: 'true not not'! !

!XeTranslateOperatorsTest methodsFor: 'tests comparison operators' stamp: 'BernardoContreras 6/9/2012 00:51'!
testTranslateNotEqual
	self assert: '2 !!= 1' equalsTranslationOf: '2 ~= 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests comparison operators' stamp: 'BernardoContreras 6/9/2012 00:51'!
testTranslateNotEqualEqual
	self assert: '2 !!= 1' equalsTranslationOf: '2 ~~ 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests bit shifting' stamp: 'BernardoContreras 6/14/2012 20:05'!
testTranslateRightShiftOperator
	self assert: '47 >> 1' equalsTranslationOf: '47 >> 1'! !

!XeTranslateOperatorsTest methodsFor: 'tests arithmetic operators' stamp: 'BernardoContreras 6/13/2012 00:04'!
testTranslateSubstraction
	self assert: '2 - 1' equalsTranslationOf: '2 - 1'! !

XeAbstractTest subclass: #XeTranslateStructTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Struct'!

!XeTranslateStructTest methodsFor: 'tests' stamp: 'BernardoContreras 7/29/2012 23:45'!
testTranslateCmdArgScenario
	self assertTranslationOf: XeCmdArgScenario 
	! !

!XeTranslateStructTest methodsFor: 'tests' stamp: 'BernardoContreras 7/14/2012 18:21'!
testTranslateSimpleStruct
	self assertTranslationOf: XeSimpleStructScenario 
	! !

XeAbstractTest subclass: #XeTranslateTemporariesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Temporaries'!

!XeTranslateTemporariesTest commentStamp: '<historical>' prior: 0!
To test the translation of the temporaries on a method or block
!

!XeTranslateTemporariesTest methodsFor: 'tests' stamp: 'BernardoContreras 8/25/2012 17:08'!
testTranslateBlockTemporaries
	self assertTranslationOf2: XeBlockTemporariesScenario 
	
	! !

!XeTranslateTemporariesTest methodsFor: 'tests' stamp: 'BernardoContreras 8/25/2012 18:50'!
testTranslateMethodTemporaries
	self assertTranslationOf2: XeMethodTemporariesScenario 
	
	! !

XeAbstractTest subclass: #XeTranslateWhileStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-While'!

!XeTranslateWhileStatementTest commentStamp: '<historical>' prior: 0!
To test the translation of the while statement
!

!XeTranslateWhileStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 5/12/2012 18:10'!
testTranslateDoWhileFalseStatement
	self assertTranslationOf: XeDoWhileFalseScenario! !

!XeTranslateWhileStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 5/13/2012 04:19'!
testTranslateDoWhileTrueStatement
	self assertTranslationOf: XeDoWhileTrueScenario! !

!XeTranslateWhileStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 5/11/2012 22:48'!
testTranslateWhileFalseDoStatement
	self assertTranslationOf: XeWhileFalseDoScenario! !

!XeTranslateWhileStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 5/12/2012 01:51'!
testTranslateWhileFalseStatement
	self assertTranslationOf: XeWhileFalseScenario! !

!XeTranslateWhileStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 5/1/2012 23:45'!
testTranslateWhileTrueDoStatement
	self assertTranslationOf: XeWhileTrueDoScenario! !

!XeTranslateWhileStatementTest methodsFor: 'tests' stamp: 'BernardoContreras 5/1/2012 23:45'!
testTranslateWhileTrueStatement
	self assertTranslationOf: XeWhileTrueScenario! !

TestCase subclass: #XeTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTypeTest methodsFor: 'tests' stamp: 'BernardoContreras 7/14/2012 02:28'!
testEmitArrayOfChar
	| writer |
	writer := XeWriter newFor: String new writeStream.
	#(#array #char) asXeType emitOn: writer.
	self assert: 'char [0]' equals:  writer contents ! !

!XeTypeTest methodsFor: 'tests' stamp: 'BernardoContreras 7/14/2012 01:59'!
testEmitFixedArrayOfChar
	| writer |
	writer := XeWriter newFor: String new writeStream.
	#(#array #char #7) asXeType emitOn: writer.
	self assert: 'char [7]' equals:  writer contents ! !

!XeTypeTest methodsFor: 'tests' stamp: 'BernardoContreras 7/9/2012 03:07'!
testEmitPointerToChar
	| writer |
	writer := XeWriter newFor: String new writeStream.
	#(#ptr #char) asXeType emitOn: writer.
	self assert: 'char *' equals:  writer contents ! !

!XeTypeTest methodsFor: 'tests' stamp: 'BernardoContreras 7/8/2012 20:49'!
testEmitSimpleType
	| writer |
	writer := XeWriter newFor: String new writeStream.
	#void asXeType emitOn: writer.
	self assert: 'void' equals:  writer contents ! !

!XeTypeTest methodsFor: 'tests' stamp: 'BernardoContreras 4/22/2012 01:50'!
testEquality
	self assert: #void asXeType = #void asXeType! !

Object subclass: #XeExpected
	instanceVariableNames: 'stream indentationLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Util'!

!XeExpected commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
To describe what it is expected as a result of the translation.
!

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 8/25/2012 16:49'!
<< aCollection
	stream tab: indentationLevel.
	stream nextPutAll: aCollection.
	self endOfStatement! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 8/22/2012 21:11'!
<<< aCollection
	stream tab: indentationLevel.
	stream
		nextPutAll: aCollection! !

!XeExpected methodsFor: 'private' stamp: 'BernardoContreras 8/27/2012 22:50'!
basicDecl: anArray
	"basic function declaration"

	anArray first asXeType emitOn: stream.
	stream space.
	stream nextPutAll: anArray second asString.
	stream nextPut: $(.
	anArray third isEmpty
		ifTrue: [ #void asXeType emitOn: stream ]
		ifFalse: [ 
			(anArray third
				pairsCollect: [ :first :second | 
					{(first asXeType).
					(second asString)} ])
				do: [ :each | 
					each first emitOn: stream.
					stream space.
					stream nextPutAll: each second ]
				separatedBy: [ 
					stream
						nextPut: $,;
						space ] ].
	stream nextPut: $)! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 8/22/2012 22:12'!
closeBrace
	self decrementIndentation.
	stream
		tab: indentationLevel;
		nextPut: $};
		cr! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 03:05'!
contents
	^ stream contents! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 7/18/2012 21:10'!
cr
	stream cr! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 8/22/2012 21:15'!
decrementIndentation
	indentationLevel := indentationLevel - 1! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 8/25/2012 16:49'!
endOfStatement
	stream
		nextPut: $;;
		cr! !

!XeExpected methodsFor: 'function' stamp: 'BernardoContreras 8/25/2012 16:50'!
fdecl: anArray
	"function declaration:
		return-type function-name (parameter-list);
	 where 
		anArray first =  return-type
		anArray second =  function-name
		anArray third =  (parameter-list)
	"

	self basicDecl: anArray.
	self endOfStatement! !

!XeExpected methodsFor: 'function' stamp: 'BernardoContreras 8/25/2012 20:17'!
fdef: anArray body: aBlock
	"
Here is the general form of a function definition:
	return-type
 	function-name (parameter-list)
	{
    	  function-body
   	}
"

	self
		basicDecl: anArray;
		openBrace.
	aBlock value.
	self closeBrace! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 8/22/2012 21:24'!
functionPrototypesComment
	self <<< '/*** Function Prototypes ***/'; cr! !

!XeExpected methodsFor: 'statements' stamp: 'BernardoContreras 8/25/2012 17:14'!
if: aString then: thenBlock
	self <<< ('if (' , aString , ')').
	stream space.
	self openBrace.
	thenBlock value.
	self closeBrace! !

!XeExpected methodsFor: 'statements' stamp: 'BernardoContreras 9/2/2012 01:22'!
if: aString then: thenBlock else: elseBlock
	self <<< ('if (' , aString , ')').
	stream space.
	self openBrace.
	thenBlock value.
	self
		decrementIndentation;
		<<< '} else ';
		openBrace.
	elseBlock value.
	self closeBrace! !

!XeExpected methodsFor: 'cpp' stamp: 'BernardoContreras 8/25/2012 16:47'!
include: aString 
	self <<< ('#include ', aString ); cr! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 8/22/2012 21:15'!
incrementIndentation
	indentationLevel := indentationLevel + 1! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 03:00'!
indentation: aNumber
	indentationLevel := aNumber! !

!XeExpected methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 02:55'!
initialize
	stream := WriteStream on: (String new: 1000).
	indentationLevel := 0! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 8/22/2012 21:07'!
openBrace
	stream
		nextPut: ${;
		cr.
	self incrementIndentation! !

!XeExpected methodsFor: 'printing' stamp: 'BernardoContreras 4/7/2012 04:00'!
printOn: aStream
	aStream nextPutAll: 'expects '.
	aStream
		nextPut: $[;
		cr.
	aStream nextPutAll: stream contents.
	aStream nextPut: $]! !

!XeExpected methodsFor: 'statements' stamp: 'BernardoContreras 8/25/2012 19:41'!
return
	self << 'return'! !

!XeExpected methodsFor: 'statements' stamp: 'BernardoContreras 8/24/2012 23:05'!
return: aString
	self << ('return ' , aString)! !

Object subclass: #XeScenarioBrowser
	instanceVariableNames: 'announcer scenario expectedContents actualContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenario-UI'!

!XeScenarioBrowser commentStamp: 'BernardoContreras 5/6/2012 02:33' prior: 0!
Browse a scenario, and see what the expected translation is, 
what the actual translation is and the diff between them.
Usage:
  XeScenarioBrowser browse: XeWhileTrueScenario 
!

!XeScenarioBrowser class methodsFor: 'instance creation' stamp: 'BernardoContreras 5/5/2012 18:21'!
browse: aScenarioClass 
	^self new browse: aScenarioClass! !

!XeScenarioBrowser methodsFor: 'accessing' stamp: 'BernardoContreras 8/19/2012 02:48'!
actualContents
	^ actualContents ! !

!XeScenarioBrowser methodsFor: 'announcement' stamp: 'BernardoContreras 8/19/2012 02:59'!
announcer

	^ announcer ifNil: [ announcer := Announcer new ]! !

!XeScenarioBrowser methodsFor: 'initialize-release' stamp: 'BernardoContreras 8/19/2012 19:55'!
browse: aScenarioClass
	scenario := aScenarioClass.
	self registerToAnnouncements.
	self updateContents.
	^ (self uiClass on: self) open! !

!XeScenarioBrowser methodsFor: 'private' stamp: 'BernardoContreras 5/6/2012 00:11'!
codeString
	| cg |
	cg := XeCodeGenerator new.
	cg addClass: scenario.
	^ cg codeString! !

!XeScenarioBrowser methodsFor: 'accessing' stamp: 'BernardoContreras 8/19/2012 02:49'!
expectedContents
	^ expectedContents ! !

!XeScenarioBrowser methodsFor: 'system announcements' stamp: 'BernardoContreras 8/19/2012 21:27'!
methodChanged: anAnnouncement
	anAnnouncement itemClass == scenario | (anAnnouncement itemClass == scenario class)
		ifTrue: [ self scenarioChanged ]! !

!XeScenarioBrowser methodsFor: 'printing' stamp: 'BernardoContreras 5/6/2012 00:17'!
printOn: aStream
	aStream nextPutAll: 'browsing: '.
	aStream nextPutAll: scenario asString! !

!XeScenarioBrowser methodsFor: 'announcement registration' stamp: 'BernardoContreras 8/19/2012 21:27'!
registerToAnnouncements
	SystemAnnouncer announcer weak
		on: MethodAdded send: #methodChanged: to: self;
		on: MethodModified send: #methodChanged: to: self;
		on: MethodRemoved send: #methodChanged: to: self! !

!XeScenarioBrowser methodsFor: 'accessing' stamp: 'BernardoContreras 6/4/2012 19:40'!
scenario
	^ scenario! !

!XeScenarioBrowser methodsFor: 'announcement' stamp: 'BernardoContreras 8/19/2012 21:34'!
scenarioChanged
	self updateContents.
	self announcer announce: XeScenarioChanged! !

!XeScenarioBrowser methodsFor: 'private' stamp: 'BernardoContreras 5/6/2012 00:11'!
uiClass
	^ XeScenarioBrowserUI! !

!XeScenarioBrowser methodsFor: 'private' stamp: 'BernardoContreras 8/25/2012 18:07'!
updateContents
	actualContents := self codeString.
	(scenario class includesSelector: #expected)
		ifTrue: [ expectedContents := scenario expected contents ].
	(scenario class includesSelector: #expectedOn:)
		ifTrue: [ 
			| writer |
			writer := XeExpected new.
			scenario expectedOn: writer.
			expectedContents := writer contents ]! !
